cls macro
push ax
xor di,di
mov ah, 7
mov al, 0
mov cx, 4000
rep stosw
xor di,di
pop ax
#EM

putc macro
mov al, #1
stosb     ; puts it on the screen
inc di    ; to skip attribute
#EM

putcr macro
call crf
#EM

puts macro
mov bp, offset(#1)  ; get the index of the string
call putsf
#EM

putln macro
puts #1
call crf
#EM

getc macro
call getcf
#EM

gets macro
push cx
mov bp, offset(#1)
mov cx,bp
call getsf
pop cx
#EM

pause macro
call pausef
#EM

setes macro
push bx
mov bx, 0B800h
mov es,bx
pop bx
#EM

quit macro
mov ax, 4C00h
int 20h
#EM

setes
xor di, di      ; start at top left of screen
jmp start

putsf:
putc ds:[bp]        ; put the character at pointer on the screen
inc bp              ; move to next character
cmp ds:[bp] B, 0h   ; check if the new one is null
jne putsf           ; if it isn't then go agian
ret

pausef:
cli             ; Nointerrupts, alters buffer
mov bx,40h
mov ds,bx       ; Load work segment
mov bx,ds:1ah   ; ...point to buffer head
cmp bx,ds:1ch   ; Ifnot equal to buffer tail
jne readchar    ; ...char waiting to be read
sti             ; Elseallow interrupts
jmp pausef      ; ...wait for him to type

readchar:
mov ax,[bx]     ;Fetch the character
inc bx          ; ...point to next character
inc bx          ; ...char = scan code + shift
mov ds:1ah,bx   ; Saveposition in head
cmp bx,ds:82h   ; ...buffer overflowed?
jne pausefx      ; ...no, done
mov bx,ds:80h   ; Elsereset to point at start
mov ds:1ah,bx   ; ...and correct head position
pausefx:
ret
 
getcf:
cli             ; Nointerrupts, alters buffer
mov bx,40h
mov ds,bx       ; Load work segment
mov bx,ds:1ah   ; ...point to buffer head
cmp bx,ds:1ch   ; Ifnot equal to buffer tail
jne readchar    ; ...char waiting to be read
sti             ; Elseallow interrupts
mov ax, 0
ret
   
getsf:
mov es:di W, 8700h+'_' ;cursor
pause              ; get keypress

cmp al, 0Dh        ; check for enter
je getsfx

cmp al,08H
je bkspace



mov ds:[bp], al       ; if not enter, load into var

inc bp             ; go to next var position

mov ah,7h          ; unblink
stosw

jmp getsf          ; do it again

bkspace:
cmp bp,cx        ;check if char pressed first
je getsf         ;if not, don't bakspace off screen

mov ds:[bp] B, 0h    ; add null
mov es:di W, 700h    ; delete cursor
dec bp               ; erase char in string
dec di               ; move back
dec di               ; needed twice

jmp getsf



getsfx:

mov ds:[bp] B, 0h     ; add null
mov es:di W, 700h    ; delete cursor

ret

crf:
cmp di, 3840
jl crfnorm
call vidscrollf
ret
crfnorm:
push bx
mov bx, di
crfloop:
cmp bx, 160
jl crfgo
sub bx, 160
jmp crfloop
crfgo:
mov bh, 160
sub bh, bl
mov bl, bh
xor bh, bh
add di, bx
pop bx
ret

putbs macro
mov es:di W, 700h    ; delete cursor
dec di               ; move back
dec di               ; skip attribute byte
#EM

vidscrollf:
push si
push ds
mov ds, es
mov si, 160
xor di, di
mov cx, 3840
rep movsb
push ax
mov di, 3840
mov ah, 7
mov al, 0
mov cx, 80
rep stosw
pop ax
mov di, 3840
pop ds
pop si
ret
