//REMEMBER: you pass the number of _bytes_ to the command line

#include <stdio.h>
#define MB 1	//sets amount of RAM in user's system
static unsigned char two[8]={1,2,4,8,16,32,64,128};

void updatetable(unsigned char *table, unsigned long ret, unsigned long kblocks)
{
	while(kblocks--)
	{
		table[ret >> 3] |= two[ret & 7];
		++ret;	
	}
}

//Finds first contiguous segment of specified number of free blocks
unsigned long findblocks(unsigned char *table, unsigned long kblocks)
{	
	unsigned long loc = 0, ret = 0;
	while(1)
	{
		while((table[loc >> 3] & two[loc & 7]) && (loc < MB*1024))
			++loc;
		if(loc == MB*1024) return 0;
		
		ret=loc;
		while(!(table[loc >> 3] & two[loc & 7]) && (loc < MB*1024))
			if(loc - ret == kblocks - 1)
			{
				updatetable(table, ret, kblocks);
				return ret;
			}	
			else ++loc;
		if(loc == MB*1024) return 0;
	}
}

void init(unsigned char *table)
{
	int loc;
	for(loc=0;loc<MB*1024;++loc)
		table[loc]=0;
}
unsigned long cmalloc(unsigned long bytes)	//actually it is a pointer
{
	static unsigned char table[MB*1024/8];
	static char initialized=0;
	unsigned long kblocks=(bytes/1024)+1; //fix case bytes%1024=0
	
	if(kblocks == 0) return 0;
	if(!initialized)
	{	
		init(table);
		initialized=1;
	}
	return findblocks(table, kblocks);
}

int main()
{
	unsigned long size=1;
	char buf[100];
	printf("malloc tester\n");
	while(size>0)
	{
		scanf("%s", buf);
		size=strtoul(buf);
		printf("&%i\n", (int)(cmalloc(size)) );
		fflush(stdin);
	}
	return 0;
}
